/*
 * Program na vypocet faze z JD pozorovani.
 * Autor: Lubos Brat
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

// DEFINICE POUZITYCH FUNKCI
float count_K(long double);
double IntPart(float);

void main(void)
{
  /* DEFINICE PROMENNYCH */
  char hvezda[20];
  char hvezda_a[10], hvezda_b[10];
  char odpad[10];
  char input_file[50];
  char output_file[50];
  char smazat, pokracovat, pom1, pom2;
  char polozka[15], line[150], input_line[150];
  char star1[10], star2[10], starc1[10], starc2[10], mag[7];
  char RA[10], DE[10], JDs[15], MAX[8], MIN[8];
  char hods[3], mins[3], secs[5], degs[3], vtes[6];
  int match, i;
  long int epoch;
  float sec, hod, min, K, cor, phase;
  double JD_cor, JDmin, M, M2;
  long double JD;
  double PER, d_hod, deg, vte, alfa, delta, beta, lambda, lambda2, lambda3;
  double lambda_s;
  double prevod = 57.29577951;  // prevodni konstanta deg<->rad
  double epsilon = 0.408988821; // v radianech
  FILE *fr, *fw;

     // VYPIS HLAVICKY A ZADANI VSTUPNICH UDAJU - OBJEKT A VSTUPNI SOUBOR S DATY
     printf("****************************************************************************\n");
     printf("*		  * program: PHASER (JD -> faze)                           *\n");
     printf("*		  * verze a datum: verze 1.3, 24.04.2000                   *\n");
     printf("*		  * autor: (c) Lubos Brat, 1999-2000               	   *\n");
     printf("****************************************************************************\n");
     printf("\n\n");

     // KONTROLA EXISTENCE SOUBORU S KATALOGEM
       if ((fr = fopen("katalog.txt", "r")) == NULL) {
	 printf("\nSoubor 'katalog.txt' nelze najit!\n");
	 printf("Overte prosim, zda je umisten v aktualnim adresari.\n\n");
	 exit(0);
       }
	fclose(fr);

     // NACTENI NAZVU OBJEKTU
   match = 0;
   do {
     printf("Zadejte nazev sledovaneho objektu: ");
     scanf("%s %s", &hvezda_a, &hvezda_b);
     fr = fopen("katalog.txt", "r");
     while (fgets(line, 150, fr) != NULL) {
       sscanf(line, "%s %s %s", &star1, &star2, &odpad);
       if ((strcmp(star1, hvezda_a) == 0) && (strcmp(star2, hvezda_b) == 0)) {
	  match = 1;
       }
     }
     fclose(fr);

     if (match == 1) {
       printf("OK: %s %s\n\n\n", hvezda_a, hvezda_b);
     }
     else {
       printf("NENALEZENO: Objekt %s %s nebyl nalezen v souboru 'katalog.txt'.\n\n", hvezda_a, hvezda_b);
      }
   } while (match != 1);



     // NACTENI NAZVU VSTUPNIHO SOUBORU
   match = 0;
   do {
     printf("Zadejte vstupni soubor s daty: ");
     scanf("%s", input_file);
     // KONTROLA EXISTENCE SOUBORU S DATY
       if ((fr = fopen(input_file, "r")) == NULL) {
	 printf("NENALEZENO: Soubor %s nebyl nalezen v aktualnim dresari!\n\n", input_file);
	 match = 0;
       } else {
	 printf("OK: %s\n\n\n", input_file);
	 match = 1;
       }
       fclose(fr);
   } while (match != 1);



     // NACTENI NAZVU VYSTUPNIHO SOUBORU
   match = 0;
   do {
     printf("Zadejte nazev vystupniho souboru: ");
     scanf("%s", output_file);

      // KONTROLA EXISTENCE VYSTUPNIHO SOUBORU
       if ((fr = fopen(output_file, "r")) == NULL) {
	 printf("OK: %s\n\n\n", output_file);
	 match = 1;
       }
       else {
	 printf("\nSoubor s nazvem %s jiz existuje!\n", output_file);
	 printf("Chcete jej prepsat? [A/N]: ");
	 scanf("%s", &smazat);
	 if (smazat == 'a' || smazat == 'A') {
	   // SOUBOR BUDE PREPSAN NOVYM OBSAHEM
	   printf("OK: %s\n\n\n", output_file);
	   match = 1;
	 }
	 else {
	   match = 0;
	 }
       }
       fclose(fr);
   } while (match != 1);

  match = 0;
  do {
  // NACTENI UDAJU O HVEZDE Z KATALOGU
  fr = fopen("katalog.txt", "r");
  while (fgets(line, 150, fr) != NULL) {
    sscanf(line, "%s%s %s", &starc1, &starc2, &odpad);
    if ((strcmp(hvezda_a,starc1) == 0) && (strcmp(hvezda_b,starc2) == 0)) {
      sscanf(line,"%s%s %s %s %lf %lf %s %s", &star1, &star2, &RA, &DE, &M, &PER, &MAX, &MIN);
    }
  }
  fclose(fr);
   printf("Hvezda    : %s %s\n", star1, star2);
   printf("RA (2000) : %s\n", RA);
   printf("DE (2000) : %s\n", DE);
   printf("M0        : %lf\n", M);
   printf("Perioda   : %12.10lf\n", PER);
   printf("Max (mag) : %s\n", MAX);
   printf("Min (mag) : %s\n", MIN);

   printf("\nJsou udaje ziskane z katalogu spravne? [A/N -> nacist znovu]: ");
   scanf("%s", &pokracovat);
   if (pokracovat == 'a' || pokracovat == 'A') {
     printf("OK: udaje v poradku.\n\n\n");
     match = 1;
   } else {
     match = 0;
   }
  } while (match != 1);


  // SEPARACE ROVNIKOVYCH SOURADNIC A PREPOCET NA STUPNE A DESETINY STUPNU
  for (i=0; i<=strlen(RA); ++i) {
    switch (i) {
      case 0 :
      case 1 :
	hods[i] = RA[i];
	break;
      case 2 :
      case 3 :
	mins[i-2] = RA[i];
	break;
      case 4 :
      case 5 :
      default :
	secs[i-4] = RA[i];
	break;
    }
  }
  hods[strlen(hods)] = '\0';
  mins[strlen(mins)] = '\0';
  secs[strlen(secs)] = '\0';
  hod = atoi(hods);
  min = atoi(mins);
  sec = atof(secs);
  min /= 60;
  sec /= 3600;
  hod = hod + min + sec;
  d_hod = 15*hod;	// rektascenze ve stupnich
  alfa = d_hod/prevod;  //rektascenze v radianech
  for (i=0; i<=strlen(DE); ++i) {
    switch (i) {
      case 0 :
      case 1 :
      case 2 :
	degs[i] = DE[i];
	break;
      case 3 :
      case 4 :
      default :
	vtes[i-3] = DE[i];
	break;
    }
  }
  degs[strlen(degs)] = '\0';
  vtes[strlen(vtes)] = '\0';
  deg = atoi(degs);
  vte = atoi(vtes);
  vte /= 60;
  deg += vte;		//deklinace ve stupnich
  delta = deg/prevod;   //deklinace v radianech


  // VYPOCET EKLIPTIKALNICH SOURADNIC
  /* Algoritmus vypoctu ekliptikalnich souradnic:

      cos(beta)*cos(lambda) = cos(delta)*cos(alfa)
      cos(beta)*sin(lambda) = sin(delta)*sin(epsilon) + cos(delta)*sin(alfa)*cos(epsilon)
		  sin(beta) = sin(delta)*cos(epsilon) - cos(delta)*sin(alfa)*sin(epsilon)

	alfa a delta jsou rovnikove souradnice hvezdy
	epsilon je uhel mezi ekliptikou a svetovym rovnikem
  */

  beta = asin( sin(delta)*cos(epsilon) - cos(delta)*sin(alfa)*sin(epsilon) );
  lambda2 = asin( (sin(delta)*sin(epsilon) + cos(delta)*sin(alfa)*cos(epsilon))/cos(beta) );
  lambda3 = acos( cos(delta)*cos(alfa)/cos(beta) );

  lambda = 0;
  if ((lambda2 == lambda3) && (lambda2 > 0)) {
    lambda = lambda3;   //prvni kvadrant
  }
  if ((lambda2 != lambda3) && (lambda2 > 0)) {
    lambda = lambda3;  //druhy kvadrant
  }
  if ((fabs(lambda2) != lambda3) && (lambda2 < 0)) {
    lambda = 3.141593 + fabs(lambda2);	//treti kvadrant
  }
  if ((fabs(lambda2) == lambda3) && (lambda2 < 0)) {
    lambda = 6.283186 + lambda2;	//ctvrty kvadrant
  }

  // VYPOCET HELIOCENTRICKE KOREKCE
  /* Algoritmus na vypocet heliocentricke korekce:
     cor = -0.00577552*cos(beta)*cos(lambda - lambda_s)
       beta a lambda jsou ekliptikalni souradnice pozorovane hvezdy
       lambda_s je ekliptikalni delka slunce

     lambda_s = 0.9856*K + 1.9*sin(K-2.6) - 79.8
       K je pocet dnu uplynulych v danem roce od 1.1. 0 hodin

   */

   fr = fopen(input_file, "r");
   fw = fopen(output_file, "w");
   fprintf(fw, "PHASE\tMAG\tJDhel\t\tJDgeo\t\tHelCor\n");
   printf("PHASE\tMAG\tJDhel\t\tJDgeo\t\tHelCor\n");
   while (fgets(input_line, 150, fr) != NULL) {
   sscanf(input_line, "%s %s", &JDs, &mag);
     JD = _atold(JDs);
     if (JD > 2400000.0000) {
	M2 = M + 2400000.0000;
     } else {
	M2 = M;
     }
     K = count_K(JD);
     lambda_s = (0.9856*K + 1.9*sin((K-2.6)/prevod) - 79.8)/prevod;
     cor = -0.00577552*cos(beta)*cos(lambda - lambda_s);
     JD_cor = JD + cor;
     epoch = (JD_cor - M2)/PER;
     JDmin = M2 + PER*epoch;
     phase = (JD_cor - JDmin)/PER;
     if (JD_cor < JDmin) {
       phase += 1;
     }
     fprintf(fw, "%5.3f\t%s\t%11.4lf\t%s\t%6.4lf\n", phase, mag, JD_cor, JDs, cor);
     fprintf(fw, "%5.3f\t%s\t%11.4lf\t%s\t%6.4lf\n", phase+1, mag, JD_cor, JDs, cor);
     printf("%5.3f\t%s\t%11.4lf\t%s\t%6.4lf\n", phase, mag, JD_cor, JDs, cor);
     printf("%5.3f\t%s\t%11.4lf\t%s\t%6.4lf\n", phase+1, mag, JD_cor, JDs, cor);

   }

   /*
   //KONTROLNI VYPIS
   fprintf(fw, "Pocet dni je %f\n", K);
   fprintf(fw, "Lambda_s = %lf\n", lambda_s);
   fprintf(fw, "Heliocentricka korekce: %lf\n", cor);
   //KONTROLNI VYPIS
   fprintf(fw, "l [rad]      : %lf\n", lambda);
   fprintf(fw, "b [rad]      : %lf\n", beta);
   fprintf(fw, "\n");
   fprintf(fw, "lambda2 = %lf\n", lambda2);
   fprintf(fw, "lambda3 = %lf\n", lambda3);
   //KONTROLNI VYPIS
   fprintf(fw, "PREVOD SOURADNIC: \n");
   fprintf(fw, "alfa [st.]   : %lf\n", d_hod);
   fprintf(fw, "delta [st.]  : %lf\n", deg);
   fprintf(fw, "alfa [rad]   : %lf\n", alfa);
   fprintf(fw, "delta [rad]  : %lf\n", delta);
   */

   fclose(fr);
   fclose(fw);

   printf("\nHOTOVO...\n");

   exit(0);

}



double IntPart(float r)
{
  unsigned long MaxRealCard = 65535.0;
  float sgn, count;

  if (r == 0.0) {
    return r;
  }
  else {
    sgn = r/fabs(r);
    count = 0.0;
    r = fabs(r);
    while (r >= MaxRealCard) {
      r = r - MaxRealCard;
      count = count+1.0;
    }
    return sgn*(count*MaxRealCard + ((double)((int)r)));
  }
}


float count_K(long double JD)
{
  float a, b, c, d, e, f, j, m, t, x;
  float K;
  int Year, Month, Day;

  x = (float)JD;
  a = IntPart(x+0.5);
  if (a < 2299161.0) {
    c = a+1524.0;
  }
  else {
    b = IntPart((a-1867216.25)/36524.25);
    c = a+b-IntPart(b/4.0)+1525.0;
  }
  d = IntPart((c-122.1)/365.25);
  e = IntPart(365.25*d);
  f = IntPart((c-e)/30.6001);
  t = c - e - IntPart(30.6001*f) + (x+0.5) - a;
  m = f - 1.0 - 12.0*IntPart(f/14.0);
  j = d - IntPart((7.0+m)/10.0);
  if (j > 4715.0) {
//    Year = (int)(j-4715.0);
    Month = (int)m;
    Day = (int)t;
  }
  else {
//    Year = 1996;
    Month = 12;
    Day = 31;
  }

  // KONTROLNI VYPIS
  //printf("ROK: %d\t", Year);
  //printf("MESIC: %d\t", Month);
  //printf("DEN: %d\t\n", Day);


  K = 30.3*(Month-1)+(Day-1);

  return K;
}
